Index: dlls/setupapi/misc.c
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/misc.c,v
retrieving revision 1.3
diff -u -b -r1.3 misc.c
--- dlls/setupapi/misc.c	2 Feb 2005 19:09:34 -0000	1.3
+++ dlls/setupapi/misc.c	12 Feb 2005 20:56:37 -0000
@@ -30,6 +30,9 @@
 #include "wine/unicode.h"
 #include "wine/debug.h"
 
+#include "setupapi_private.h"
+
+
 WINE_DEFAULT_DEBUG_CHANNEL(setupapi);
 
 
@@ -458,3 +461,37 @@
 
     return bResult;
 }
+
+
+BOOL WINAPI DelayedMove(LPCWSTR lpExistingFileName, LPCWSTR lpNewFileName)
+{
+    return MoveFileExW(lpExistingFileName, lpNewFileName,
+                       MOVEFILE_REPLACE_EXISTING | MOVEFILE_DELAY_UNTIL_REBOOT);
+}
+
+
+BOOL WINAPI FileExists(LPCWSTR lpFileName, LPWIN32_FIND_DATAW lpFileFindData)
+{
+    WIN32_FIND_DATAW FindData;
+    HANDLE hFind;
+    UINT uErrorMode;
+    DWORD dwError;
+
+    uErrorMode = SetErrorMode(SEM_FAILCRITICALERRORS);
+
+    hFind = FindFirstFileW(lpFileName, &FindData);
+    if (hFind == INVALID_HANDLE_VALUE)
+    {
+        dwError = GetLastError();
+        SetErrorMode(uErrorMode);
+        SetLastError(dwError);
+        return FALSE;
+    }
+
+    FindClose(hFind);
+
+    if (lpFileFindData)
+        memcpy(lpFileFindData, &FindData, sizeof(WIN32_FIND_DATAW));
+
+    return TRUE;
+}
Index: dlls/setupapi/setupapi.spec
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/setupapi.spec,v
retrieving revision 1.35
diff -u -b -r1.35 setupapi.spec
--- dlls/setupapi/setupapi.spec	2 Feb 2005 19:09:34 -0000	1.35
+++ dlls/setupapi/setupapi.spec	12 Feb 2005 20:56:38 -0000
@@ -194,14 +194,14 @@
 @ stub CaptureStringArg
 @ stub CenterWindowRelativeToParent
 @ stub ConcatenatePaths
-@ stub DelayedMove
+@ stdcall DelayedMove(wstr wstr)
 @ stub DelimStringToMultiSz
 @ stub DestroyTextFileReadBuffer
 @ stdcall DoesUserHavePrivilege(wstr)
 @ stdcall DuplicateString(wstr)
 @ stdcall EnablePrivilege(wstr long)
 @ stub ExtensionPropSheetPageProc
-@ stub FileExists
+@ stdcall FileExists(wstr ptr)
 @ stub FreeStringArray
 @ stub GetCurrentDriverSigningPolicy
 @ stub GetNewInfName
Index: include/setupapi.h
===================================================================
RCS file: /home/wine/wine/include/setupapi.h,v
retrieving revision 1.23
diff -u -b -r1.23 setupapi.h
--- include/setupapi.h	2 Feb 2005 19:09:33 -0000	1.23
+++ include/setupapi.h	12 Feb 2005 20:56:41 -0000
@@ -666,9 +666,11 @@
 
 
 LONG     WINAPI AddTagToGroupOrderList(PCWSTR lpGroupName, DWORD dwUnknown2, DWORD dwUnknown3);
+BOOL     WINAPI DelayedMove(PCWSTR lpExistingFileName, PCWSTR lpNewFileName);
 BOOL     WINAPI DoesUserHavePrivilege(PCWSTR lpPrivilegeName);
 PWSTR    WINAPI DuplicateString(PCWSTR lpSrc);
 BOOL     WINAPI EnablePrivilege(PCWSTR lpPrivilegeName, BOOL bEnable);
+BOOL     WINAPI FileExists(PCWSTR lpFileName, PWIN32_FIND_DATAW lpFileFindData);
 void     WINAPI InstallHinfSectionA( HWND hwnd, HINSTANCE handle, PCSTR cmdline, INT show );
 void     WINAPI InstallHinfSectionW( HWND hwnd, HINSTANCE handle, PCWSTR cmdline, INT show );
 #define         InstallHinfSection WINELIB_NAME_AW(InstallHinfSection)
